## shadowsocks-libev 3.2.5+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

set(PROJECT_NAME shadowsocks-libev)
set(RELEASE_DATE 2019-03-09)
set(PROJECT_VERSION "3.2.5")
set(PROJECT_DESC "a lightweight secured socks5 proxy")
set(PROJECT_URL "https://shadowsocks.org")
set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
project(${PROJECT_NAME})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")

#set(CMAKE_BINARY_DIR ${CMAKE_SOURCE_DIR}/out)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
set(RUNTIME_SHARED_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/shared/bin)

set(CMAKE_MACOSX_RPATH TRUE)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif ()
# Detect linux
if (UNIX AND NOT APPLE)
    set(LINUX TRUE)
endif ()

message(STATUS "Running cmake version ${CMAKE_VERSION}")

option(WITH_STATIC "build with static libraries." ON)
option(WITH_EMBEDDED_SRC "build with embedded libcork, libipset, and libbloom source." ON)

# Will set GIT_EXECUTABLE and GIT_FOUND
# find_package(Git)

# Run platform tests
include(${CMAKE_SOURCE_DIR}/cmake/configure.cmake)
configure_file(${CMAKE_SOURCE_DIR}/cmake/config.h.cmake ${CMAKE_BINARY_DIR}/src/config.h)
add_definitions(-I$(CMAKE_BINARY_DIR)/src)
add_definitions(-DHAVE_CONFIG_H)

# pkg-config
configure_file(
        ${CMAKE_SOURCE_DIR}/cmake/shadowsocks-libev.pc.cmake
        ${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
        @ONLY
)
install(FILES
        ${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
        DESTINATION pkgconfig
        )

if (WITH_EMBEDDED_SRC)
# We need libcork,libipset headers
include_directories(libcork/include)
include_directories(libipset/include)
include_directories(libbloom/murmur2)
include_directories(libbloom)

set(LIBCORK_SOURCE
        libcork/src/libcork/cli/commands.c
        libcork/src/libcork/core/allocator.c
        libcork/src/libcork/core/error.c
        libcork/src/libcork/core/gc.c
        libcork/src/libcork/core/hash.c
        libcork/src/libcork/core/ip-address.c
        libcork/src/libcork/core/mempool.c
        libcork/src/libcork/core/timestamp.c
        libcork/src/libcork/core/u128.c
        libcork/src/libcork/core/version.c
        libcork/src/libcork/ds/array.c
        libcork/src/libcork/ds/bitset.c
        libcork/src/libcork/ds/buffer.c
        libcork/src/libcork/ds/dllist.c
        libcork/src/libcork/ds/file-stream.c
        libcork/src/libcork/ds/hash-table.c
        libcork/src/libcork/ds/managed-buffer.c
        libcork/src/libcork/ds/ring-buffer.c
        libcork/src/libcork/ds/slice.c
        libcork/src/libcork/posix/directory-walker.c
        libcork/src/libcork/posix/env.c
        libcork/src/libcork/posix/exec.c
        libcork/src/libcork/posix/files.c
        libcork/src/libcork/posix/process.c
        libcork/src/libcork/posix/subprocess.c
        libcork/src/libcork/pthreads/thread.c
        )

if (WITH_STATIC)
add_library(cork STATIC ${LIBCORK_SOURCE})
target_compile_definitions(cork PUBLIC -DCORK_API=CORK_LOCAL)
endif ()

add_library(cork-shared SHARED ${LIBCORK_SOURCE})
target_compile_definitions(cork-shared PUBLIC -DCORK_API=CORK_EXPORT)
set_target_properties(cork-shared PROPERTIES OUTPUT_NAME cork)

set(LIBIPSET_SOURCE
        libipset/src/libipset/general.c
        libipset/src/libipset/bdd/assignments.c
        libipset/src/libipset/bdd/basics.c
        libipset/src/libipset/bdd/bdd-iterator.c
        libipset/src/libipset/bdd/expanded.c
        libipset/src/libipset/bdd/reachable.c
        libipset/src/libipset/bdd/read.c
        libipset/src/libipset/bdd/write.c
        libipset/src/libipset/map/allocation.c
        libipset/src/libipset/map/inspection.c
        libipset/src/libipset/map/ipv4_map.c
        libipset/src/libipset/map/ipv6_map.c
        libipset/src/libipset/map/storage.c
        libipset/src/libipset/set/allocation.c
        libipset/src/libipset/set/inspection.c
        libipset/src/libipset/set/ipv4_set.c
        libipset/src/libipset/set/ipv6_set.c
        libipset/src/libipset/set/iterator.c
        libipset/src/libipset/set/storage.c
        )

if (WITH_STATIC)
add_library(ipset STATIC ${LIBIPSET_SOURCE})
endif ()

add_library(ipset-shared SHARED ${LIBIPSET_SOURCE})
set_target_properties(ipset-shared PROPERTIES OUTPUT_NAME ipset)

set(LIBBLOOM_SOURCE
        libbloom/bloom.c
        libbloom/murmur2/MurmurHash2.c
        )

if (WITH_STATIC)
add_library(bloom STATIC ${LIBBLOOM_SOURCE})
target_link_libraries(ipset cork bloom)
endif ()

add_library(bloom-shared SHARED ${LIBBLOOM_SOURCE})
target_link_libraries(ipset-shared cork-shared bloom-shared)
set_target_properties(bloom-shared PROPERTIES OUTPUT_NAME bloom)
endif ()

add_subdirectory(src)
add_subdirectory(doc)

=== .copr/Makefile ===
.PHONY: deps srpm
.DEFAULT_GOAL := srpm

DOT_COPR := $(dir $(firstword $(MAKEFILE_LIST)))
TOP_DIR := $(realpath $(DOT_COPR)/../)

RPM_DIR := $(TOP_DIR)/rpm
outdir ?= $(RPM_DIR)/SRPMS

HAS_GIT := $(shell command -v git 2> /dev/null)
ifndef HAS_GIT
deps:
	dnf -y install git
else
deps:
endif

srpm: deps
	$(TOP_DIR)/rpm/genrpm.sh -o $(outdir)

=== doc/CMakeLists.txt ===
find_program(XMLTO_EXECUTABLE NAMES xmlto)
find_program(ASCIIDOC_EXECUTABLE NAMES asciidoc asciidoc.py)

# Opt-in doc build option
if (NOT XMLTO_EXECUTABLE OR NOT ASCIIDOC_EXECUTABLE)
    option(WITH_DOC_MAN "Build manpage doc" OFF)
else ()
    option(WITH_DOC_MAN "Build manpage doc" ON)
endif ()

if (NOT ASCIIDOC_EXECUTABLE)
    option(WITH_DOC_HTML "Build html doc" OFF)
else ()
    option(WITH_DOC_HTML "Build html doc" ON)
endif ()

# NOTE For brew user, we have to setup this env var. see `brew info asciidoc'
set(XMLTO_ENV)
set(XMLTO_CATALOG_DIR_MACOS /usr/local/etc/xml/catalog)
if (EXISTS ${XMLTO_CATALOG_DIR_MACOS})
    set(XMLTO_ENV XML_CATALOG_FILES=${XMLTO_CATALOG_DIR_MACOS})
    message(STATUS "Detect xmlto catalog dir ${XMLTO_CATALOG_DIR_MACOS}")
endif ()

set(CMAKE_MANPAGE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/man)

set(DOC_DIR ${CMAKE_SOURCE_DIR}/doc)
set(XMLTO_OPTS -m ${DOC_DIR}/manpage-normal.xsl -m ${DOC_DIR}/manpage-bold-literal.xsl man)
set(ASCIIDOC_XML_OPTS -b docbook -d manpage -f ${DOC_DIR}/asciidoc.conf -aversion=${PROJECT_VERSION})
set(ASCIIDOC_HTML_OPTS -b html4 -d article -f ${DOC_DIR}/asciidoc.conf -aversion=${PROJECT_VERSION})


set(MAN_NAMES ss-local.1 ss-manager.1 ss-nat.1 ss-redir.1 ss-server.1 ss-tunnel.1 shadowsocks-libev.8)
set(MAN_FILES)
set(HTML_FILES)

foreach (manfile IN LISTS MAN_NAMES)
    string(REGEX REPLACE \\.. .xml xmlfile ${manfile})
    string(REGEX REPLACE \\.. .asciidoc docfile ${manfile})
    string(REGEX REPLACE \\.. .html htmlfile ${manfile})

    set(docfile ${DOC_DIR}/${docfile})

    add_custom_command(OUTPUT ${manfile}
            COMMAND ${ASCIIDOC_EXECUTABLE} ${ASCIIDOC_XML_OPTS} -o ${xmlfile} ${docfile}
            COMMAND ${CMAKE_COMMAND} -E env ${XMLTO_ENV} ${XMLTO_EXECUTABLE} ${XMLTO_OPTS} ${xmlfile}
            # After we built the manpage, the xmlfile is nolongger needed
            COMMAND ${CMAKE_COMMAND} -E remove ${xmlfile}
            DEPENDS ${docfile}
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/man
            COMMENT "Building manpage ${manfile}"
            VERBATIM)
    list(APPEND MAN_FILES ${manfile})

    add_custom_command(OUTPUT ${htmlfile}
            COMMAND ${ASCIIDOC_EXECUTABLE} ${ASCIIDOC_HTML_OPTS} -o ${htmlfile} ${docfile}
            DEPENDS ${docfile}
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/html
            COMMENT "Building htmlfile ${htmlfile}"
            VERBATIM)
    list(APPEND HTML_FILES ${htmlfile})
endforeach ()

add_custom_target(doc-man ALL DEPENDS ${MAN_FILES})
add_custom_target(doc-html ALL DEPENDS ${HTML_FILES})


if (NOT WITH_DOC_MAN)
    set_target_properties(doc-man PROPERTIES EXCLUDE_FROM_ALL TRUE)
else ()
    install(DIRECTORY ${CMAKE_BINARY_DIR}/man/
            DESTINATION man)
endif ()
if (NOT WITH_DOC_HTML)
    set_target_properties(doc-html PROPERTIES EXCLUDE_FROM_ALL TRUE)
else ()
    install(DIRECTORY ${CMAKE_BINARY_DIR}/html/
            DESTINATION doc/html)
endif ()

# This is required for custom command
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/man)
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/html)

=== src/CMakeLists.txt ===
# redir need linux/* stuff
if (LINUX)
    option(WITH_SS_REDIR "Build ss-redir" ON)
else ()
    option(WITH_SS_REDIR "Build ss-redir" OFF)
endif ()


set(SS_SNI_SOURCE
        http.c
        tls.c
        )

set(SS_ACL_SOURCE
        acl.c
        rule.c
        )

set(SS_CRYPTO_SOURCE
        crypto.c
        aead.c
        stream.c
        base64.c
        )

set(SS_PLUGIN_SOURCE
        plugin.c
        )

set(SS_SHARED_SOURCES
        ppbloom.c
        utils.c
        jconf.c
        json.c
        netutils.c
        )

set(LIBSHADOWSOCKS_LIBEV_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        local.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_SNI_SOURCE}
        ${SS_ACL_SOURCE}
        )

set(SS_LOCAL_SOURCE
        ${LIBSHADOWSOCKS_LIBEV_SOURCE}

        )

set(SS_TUNNEL_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        tunnel.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        )

set(SS_SERVER_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        resolv.c
        server.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_SNI_SOURCE}
        ${SS_ACL_SOURCE}
        )

set(SS_MANAGER_SOURCE
        ${SS_SHARED_SOURCES}
        manager.c
        )

set(SS_REDIR_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        redir.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        )

if (CMAKE_SYSTEM_NAME STREQUAL Darwin)
find_path(LIBSODIUM_INCLUDE_DIR sodium.h
        PATHS
        $ENV{LIBSODIUM_INCLUDE_DIR}
        $ENV{LIBSODIUM_DIR}/include
        /usr/local/libsodium/include
        /opt/libsodium/include
        /usr/local/include
)
include_directories(${LIBSODIUM_INCLUDE_DIR})
endif ()

if (WITH_STATIC)
find_library(LIBSODIUM libsodium.a)
find_library(LIBMBEDTLS libmbedtls.a)
find_library(LIBMBEDCRYPTO libmbedcrypto.a)
find_library(LIBEV libev.a)
find_library(LIBUDNS libcares.a)
find_library(LIBPCRE libpcre.a)

# Dependencies we need for static and shared
list(APPEND DEPS
        m
        bloom
        ${LIBEV}
        ${LIBUDNS}
        ${LIBPCRE}
        ${LIBSODIUM}
        ${LIBMBEDTLS}
        ${LIBMBEDCRYPTO}
        )
endif ()

find_library(LIBSODIUM_SHARED sodium)
find_library(LIBMBEDTLS_SHARED mbedtls)
find_library(LIBMBEDCRYPTO_SHARED mbedcrypto)
find_library(LIBEV_SHARED ev)
find_library(LIBUDNS_SHARED cares)
find_library(LIBPCRE_SHARED pcre)

if (WITH_EMBEDDED_SRC)
list(APPEND DEPS_SHARED
        m
        bloom-shared
        cork-shared
        ipset-shared
        ${LIBEV_SHARED}
        ${LIBUDNS_SHARED}
        ${LIBPCRE_SHARED}
        ${LIBSODIUM_SHARED}
        ${LIBMBEDTLS_SHARED}
        ${LIBMBEDCRYPTO_SHARED}
        )
else ()
find_library(LIBBLOOM_SHARED bloom)
find_library(LIBCORK_SHARED cork)
find_library(LIBCORKIPSET_SHARED corkipset)
list(APPEND DEPS_SHARED
        m
        ${LIBBLOOM_SHARED}
        ${LIBCORK_SHARED}
        ${LIBCORKIPSET_SHARED}
        ${LIBEV_SHARED}
        ${LIBUDNS_SHARED}
        ${LIBPCRE_SHARED}
        ${LIBSODIUM_SHARED}
        ${LIBMBEDTLS_SHARED}
        ${LIBMBEDCRYPTO_SHARED}
        )
endif ()

find_package (Threads)

if (WITH_STATIC)
# ------------------------------------------------------------------
# Static
# By default we use normal name for static, all shared targets will add a `-shared' suffix
add_executable(ss-server ${SS_SERVER_SOURCE})
add_executable(ss-tunnel ${SS_TUNNEL_SOURCE})
add_executable(ss-manager ${SS_MANAGER_SOURCE})
add_executable(ss-local ${SS_LOCAL_SOURCE})
if (WITH_SS_REDIR)
    add_executable(ss-redir ${SS_REDIR_SOURCE})
else ()
    add_executable(ss-redir EXCLUDE_FROM_ALL ${SS_REDIR_SOURCE})
endif ()
add_library(shadowsocks-libev STATIC ${LIBSHADOWSOCKS_LIBEV_SOURCE})


target_compile_definitions(ss-server PUBLIC -DMODULE_REMOTE)
target_compile_definitions(ss-tunnel PUBLIC -DMODULE_TUNNEL)
target_compile_definitions(ss-manager PUBLIC -DMODULE_MANAGER)
target_compile_definitions(ss-local PUBLIC -DMODULE_LOCAL)
target_compile_definitions(ss-redir PUBLIC -DMODULE_REDIR)
target_compile_definitions(shadowsocks-libev PUBLIC -DMODULE_LOCAL)

target_link_libraries(ss-server cork ipset ${DEPS})
target_link_libraries(ss-tunnel cork ${DEPS})
target_link_libraries(ss-manager m bloom cork ${LIBEV} ${LIBUDNS})
target_link_libraries(ss-local cork ipset ${DEPS})
target_link_libraries(ss-redir cork ipset ${DEPS})
target_link_libraries(shadowsocks-libev cork ipset ${DEPS})
endif ()

# ------------------------------------------------------------------
# Shared
# Shared target will have a `-shared' suffix
# All shared dependency also have `-shared' suffix
# For shared binary, we still use the same name as static, without `-shared', but will output to shared directory
add_executable(ss-server-shared ${SS_SERVER_SOURCE})
add_executable(ss-tunnel-shared ${SS_TUNNEL_SOURCE})
add_executable(ss-manager-shared ${SS_MANAGER_SOURCE})
add_executable(ss-local-shared ${SS_LOCAL_SOURCE})
if (WITH_SS_REDIR)
    add_executable(ss-redir-shared ${SS_REDIR_SOURCE})
else ()
    add_executable(ss-redir-shared EXCLUDE_FROM_ALL ${SS_REDIR_SOURCE})
endif ()
add_library(shadowsocks-libev-shared SHARED ${LIBSHADOWSOCKS_LIBEV_SOURCE})

target_compile_definitions(ss-server-shared PUBLIC -DMODULE_REMOTE)
target_compile_definitions(ss-tunnel-shared PUBLIC -DMODULE_TUNNEL)
target_compile_definitions(ss-manager-shared PUBLIC -DMODULE_MANAGER)
target_compile_definitions(ss-local-shared PUBLIC -DMODULE_LOCAL)
target_compile_definitions(ss-redir-shared PUBLIC -DMODULE_REDIR)
target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)

target_link_libraries(ss-server-shared ${DEPS_SHARED})
target_link_libraries(ss-tunnel-shared ${DEPS_SHARED})
target_link_libraries(ss-manager-shared ${CMAKE_THREAD_LIBS_INIT} ${LIBEV_SHARED} ${LIBUDNS_SHARED} ${DEPS_SHARED})
target_link_libraries(ss-local-shared ${DEPS_SHARED})
target_link_libraries(ss-redir-shared ${DEPS_SHARED})
target_link_libraries(shadowsocks-libev-shared ${DEPS_SHARED})

set_target_properties(ss-server-shared PROPERTIES OUTPUT_NAME ss-server)
set_target_properties(ss-tunnel-shared PROPERTIES OUTPUT_NAME ss-tunnel)
set_target_properties(ss-manager-shared PROPERTIES OUTPUT_NAME ss-manager)
set_target_properties(ss-local-shared PROPERTIES OUTPUT_NAME ss-local)
set_target_properties(ss-redir-shared PROPERTIES OUTPUT_NAME ss-redir)

set_target_properties(ss-server-shared ss-tunnel-shared ss-manager-shared ss-local-shared ss-redir-shared
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_SHARED_OUTPUT_DIRECTORY}
        )

set_target_properties(shadowsocks-libev-shared PROPERTIES OUTPUT_NAME shadowsocks-libev)
target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)
target_link_libraries(shadowsocks-libev-shared ${DEPS_SHARED})

# ------------------------------------------------------------------
# Misc
# Recommend to install shared by default
install(DIRECTORY ${RUNTIME_SHARED_OUTPUT_DIRECTORY}/
        USE_SOURCE_PERMISSIONS
        DESTINATION bin)

if (WITH_STATIC)
    install(TARGETS shadowsocks-libev
        ARCHIVE DESTINATION lib)
endif ()

install(TARGETS shadowsocks-libev-shared
        LIBRARY DESTINATION lib)

install(FILES shadowsocks.h DESTINATION include)


add_custom_target(distclean
        COMMAND ${CMAKE_COMMAND} -E echo WARNING: distclean target is not functional
        COMMAND ${CMAKE_COMMAND} -E echo Use 'git clean -fdx' instead
        VERBATIM
        )

=== docker/mingw/Makefile ===
#
# Makefile for building MinGW port
#
# This file is part of the shadowsocks-libev.
#
# shadowsocks-libev is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# shadowsocks-libev is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with shadowsocks-libev; see the file COPYING. If not, see
# <http://www.gnu.org/licenses/>.
#

REPO=shadowsocks
REV=master
PLUGIN=true
IMAGE=ss-build-mingw
DIST=ss-libev-win-dist.tar.gz

all: build

build:
	docker build --force-rm -t $(IMAGE) \
	  --build-arg REV=$(REV) --build-arg REPO=$(REPO) \
	  --build-arg REBUILD="$$(date +%Y-%m-%d-%H-%M-%S)" \
	  --build-arg PLUGIN=$(PLUGIN) .
	docker run --rm --entrypoint cat $(IMAGE) /bin.tgz > $(DIST)

clean:
	rm -f $(DIST)
	docker rmi $(IMAGE) || true

.PHONY: all clean build

=== debian/changelog ===
shadowsocks-libev (3.2.5+ds-1) unstable; urgency=high

  * New upstream release: v3.2.5
    + Fix a bug in port parser.
  * debian/patches: Cherry-pick several important upstream patches:
    + backport/0001: Fix upstream issue #3214 that make the plugin
      crash.
    + backport/0002: Fix and refine ipv6only support.

 -- Boyuan Yang <byang@debian.org>  Wed, 20 Mar 2019 11:35:43 -0400

=== debian/control ===
Source: shadowsocks-libev
Section: net
Priority: optional
Maintainer: Roger Shimizu <rosh@debian.org>
Uploaders:
 Max Lv <max.c.lv@gmail.com>,
 Boyuan Yang <byang@debian.org>,
 Debian Bridges Team <team+bridges@tracker.debian.org>
Build-Depends:
 asciidoc-base | asciidoc,
 debhelper (>= 10),
 libbloom-dev,
 libc-ares-dev,
 libcork-dev (>= 0.15.0+ds-8),
 libcorkipset-dev,
 libev-dev,
 libmbedtls-dev,
 libpcre3-dev,
 libsodium-dev (>= 1.0.12),
 pkg-config,
 xmlto,
Standards-Version: 4.3.0
Homepage: https://www.shadowsocks.org
Vcs-Git: https://salsa.debian.org/bridges-team/shadowsocks-libev.git
Vcs-Browser: https://salsa.debian.org/bridges-team/shadowsocks-libev

Package: libshadowsocks-libev-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Breaks:
 shadowsocks-libev (<< 2.4.0),
Depends:
 libshadowsocks-libev2 (= ${binary:Version}),
 ${misc:Depends},
Description: lightweight and secure socks5 proxy (development files)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides C header files for the libraries.

Package: libshadowsocks-libev2
Architecture: any
Multi-Arch: same
Section: libs
Replaces:
 libshadowsocks-libev1,
Breaks:
 libshadowsocks-libev1,
 shadowsocks-libev (<< 2.4.0),
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: lightweight and secure socks5 proxy (shared library)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides shared libraries.

Package: shadowsocks-libev
Replaces:
 shadowsocks (<< 1.5.3-2),
Breaks:
 shadowsocks (<< 1.5.3-2),
Architecture: any
Depends:
 libcap2-bin [linux-any],
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 haveged,
 kcptun,
 simple-obfs,
Description: lightweight and secure socks5 proxy
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.

## shadowsocks-libev 3.3.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,12 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2019-03-09)
-set(PROJECT_VERSION "3.2.5")
+set(RELEASE_DATE 2019-06-08)
+set(PROJECT_VERSION "3.3.0")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
-project(${PROJECT_NAME})
+project(${PROJECT_NAME} VERSION ${PROJECT_VERSION})
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
 
@@ -35,6 +35,11 @@
 # Will set GIT_EXECUTABLE and GIT_FOUND
 # find_package(Git)
 
+# When choose to not use embedded libcork, libipset and libbloom, use libs shipped by system
+if (NOT WITH_EMBEDDED_SRC)
+    set(USE_SYSTEM_SHARED_LIB TRUE)
+endif ()
+
 # Run platform tests
 include(${CMAKE_SOURCE_DIR}/cmake/configure.cmake)
 configure_file(${CMAKE_SOURCE_DIR}/cmake/config.h.cmake ${CMAKE_BINARY_DIR}/src/config.h)
@@ -49,7 +54,7 @@
 )
 install(FILES
         ${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
-        DESTINATION pkgconfig
+        DESTINATION lib/pkgconfig
         )
 
 if (WITH_EMBEDDED_SRC)

=== debian/changelog ===
shadowsocks-libev (3.3.0+ds-1~bpo10+2) buster-backports; urgency=medium

  * Source only upload for buster-backports.

 -- Roger Shimizu <rosh@debian.org>  Fri, 16 Aug 2019 23:04:16 +0900

shadowsocks-libev (3.3.0+ds-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Roger Shimizu <rosh@debian.org>  Fri, 26 Jul 2019 23:43:34 -0300

shadowsocks-libev (3.3.0+ds-1) unstable; urgency=medium

  [ Roger Shimizu ]
  * New upstream release: v3.3.0
    - Enlarge the socket buffer size to 16KB.
    - Fix the empty list bug in ss-manager.
    - Fix the IPv6 address parser.
  * debian/libshadowsocks-libev2.symbols: Update to fix FTBFS.

  [ Boyuan Yang ]
  * debian/*.service: Sync with upstream and require
    network-online.target instead of network.target.
  * debian/control: Bump Standards-Version to 4.4.0.
  * debian/shadowsocks-libev.lintian-overrides: Add overrides
    for systemd service templates that cannot fallback to sysvinit
    scripts.

 -- Boyuan Yang <byang@debian.org>  Sun, 14 Jul 2019 13:49:01 -0400

## shadowsocks-libev 3.3.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2019-06-08)
-set(PROJECT_VERSION "3.3.0")
+set(RELEASE_DATE 2019-08-09)
+set(PROJECT_VERSION "3.3.1")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
@@ -18,6 +18,8 @@
 set(RUNTIME_SHARED_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/shared/bin)
 
 set(CMAKE_MACOSX_RPATH TRUE)
+
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Debug)

=== debian/changelog ===
shadowsocks-libev (3.3.1+ds-1) unstable; urgency=medium

  * New upstream release: v3.3.1
    - Fix a high CPU bug introduced in 3.3.0.
    - Fix MinGW build.
    - Minor bug fixes.

 -- Roger Shimizu <rosh@debian.org>  Thu, 15 Aug 2019 01:54:34 +0900

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libsodium-dev (>= 1.0.12),
  pkg-config,
  xmlto,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://www.shadowsocks.org
 Vcs-Git: https://salsa.debian.org/bridges-team/shadowsocks-libev.git
 Vcs-Browser: https://salsa.debian.org/bridges-team/shadowsocks-libev

## shadowsocks-libev 3.3.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2019-08-09)
-set(PROJECT_VERSION "3.3.1")
+set(RELEASE_DATE 2019-10-12)
+set(PROJECT_VERSION "3.3.2")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.3.2+ds-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Boyuan Yang <byang@debian.org>  Fri, 25 Oct 2019 12:24:15 -0400

shadowsocks-libev (3.3.2+ds-1) unstable; urgency=medium

  * New upstream release: v3.3.2
    + Refine the handling of fragment request.
    + Minor bug fixes.
  * debian/control:
    + Bump Standards-Version to 4.4.1.
  * debian/libshadowsocks-libev2.symbols: Add new symbol.

 -- Boyuan Yang <byang@debian.org>  Mon, 14 Oct 2019 14:51:22 -0400

shadowsocks-libev (3.3.1+ds-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Roger Shimizu <rosh@debian.org>  Sat, 17 Aug 2019 00:40:44 +0900

shadowsocks-libev (3.3.0+ds-1~bpo9+1) stretch-backports-sloppy; urgency=medium

  * Rebuild for stretch-backports-sloppy.

 -- Roger Shimizu <rosh@debian.org>  Fri, 26 Jul 2019 23:53:56 -0300

shadowsocks-libev (3.2.5+ds-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 20 Mar 2019 12:04:17 -0400

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libsodium-dev (>= 1.0.12),
  pkg-config,
  xmlto,
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://www.shadowsocks.org
 Vcs-Git: https://salsa.debian.org/bridges-team/shadowsocks-libev.git
 Vcs-Browser: https://salsa.debian.org/bridges-team/shadowsocks-libev

## shadowsocks-libev 3.3.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2019-10-12)
-set(PROJECT_VERSION "3.3.2")
+set(RELEASE_DATE 2019-10-31)
+set(PROJECT_VERSION "3.3.3")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.3.3+ds-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Roger Shimizu <rosh@debian.org>  Tue, 26 Nov 2019 00:31:53 +0900

shadowsocks-libev (3.3.3+ds-1) unstable; urgency=medium

  * debian/*.service:
    - Run service in DynamicUser (Closes: #934186).
  * debian/control:
    - Use tracker mail as maintainer address.
  * debian/copyright:
    - Update copyright year and debian email for my entry.
  * debian/patches:
    - Add a patch to amend shadowsocks-libev.pc.in,
      to remove crypto library dependency. Thanks to lintian.

 -- Roger Shimizu <rosh@debian.org>  Sat, 23 Nov 2019 14:29:07 +0900

shadowsocks-libev (3.3.2+ds-1~bpo9+1) stretch-backports-sloppy; urgency=medium

  * Rebuild for stretch-backports-sloppy.

 -- Roger Shimizu <rosh@debian.org>  Thu, 31 Oct 2019 02:45:52 +0900

shadowsocks-libev (3.3.1+ds-1~bpo9+1) stretch-backports-sloppy; urgency=medium

  * Rebuild for stretch-backports-sloppy.

 -- Roger Shimizu <rosh@debian.org>  Sat, 17 Aug 2019 00:43:17 +0900

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: shadowsocks-libev
 Section: net
 Priority: optional
-Maintainer: Roger Shimizu <rosh@debian.org>
+Maintainer: Debian Bridges Team <team+bridges@tracker.debian.org>
 Uploaders:
  Max Lv <max.c.lv@gmail.com>,
  Boyuan Yang <byang@debian.org>,
- Debian Bridges Team <team+bridges@tracker.debian.org>
+ Roger Shimizu <rosh@debian.org>
 Build-Depends:
  asciidoc-base | asciidoc,
  debhelper (>= 10),

## shadowsocks-libev 3.3.4%2Bds

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Dummy folder for autotools scripts
LIBDIR=libbloom libcork libipset

override_dh_auto_clean:
	# dh_auto_clean and dh_autoreconf complains if there're no these folders
	# they're removed after dh_autoreconf
	for libdir in ${LIBDIR}; do \
		mkdir -p $$libdir; \
		touch $$libdir/Makefile.in; \
	done
	dh_auto_clean
	# dpkg-buildpackage complains these files from previous built
	find -name Makefile -exec rm {} \;
	rm -f config.h config.log config.status libtool shadowsocks-libev.pc stamp-h1

override_dh_autoreconf:
	dh_autoreconf
	rm -rf ${LIBDIR}

override_dh_auto_configure:
	# Whether to have stack-protector is decided by dpkg-buildflags.
	# So --disable-ssp here should be safe. See Bug#829498
	dh_auto_configure -- \
		--enable-shared \
		--enable-system-shared-lib \
		--disable-ssp

override_dh_install:
	# remove libtool library
	rm -f debian/tmp/usr/lib/*/*.la
	dh_install

override_dh_missing:
	dh_missing --fail-missing

%:
	dh $@

## shadowsocks-libev 3.3.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2019-10-31)
-set(PROJECT_VERSION "3.3.3")
+set(RELEASE_DATE 2020-01-10)
+set(PROJECT_VERSION "3.3.4")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
 endif ()
 
 set(CMAKE_MANPAGE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/man)
+set(CMAKE_HTML_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/html)
 
 set(DOC_DIR ${CMAKE_SOURCE_DIR}/doc)
 set(XMLTO_OPTS -m ${DOC_DIR}/manpage-normal.xsl -m ${DOC_DIR}/manpage-bold-literal.xsl man)
@@ -39,6 +40,8 @@
     string(REGEX REPLACE \\.. .asciidoc docfile ${manfile})
     string(REGEX REPLACE \\.. .html htmlfile ${manfile})
 
+    set(manfile ${CMAKE_MANPAGE_OUTPUT_DIRECTORY}/${manfile})
+    set(htmlfile ${CMAKE_HTML_OUTPUT_DIRECTORY}/${htmlfile})
     set(docfile ${DOC_DIR}/${docfile})
 
     add_custom_command(OUTPUT ${manfile}
@@ -69,13 +72,19 @@
     set_target_properties(doc-man PROPERTIES EXCLUDE_FROM_ALL TRUE)
 else ()
     install(DIRECTORY ${CMAKE_BINARY_DIR}/man/
-            DESTINATION man)
+            DESTINATION share/man/man1
+            FILES_MATCHING PATTERN "*.1"
+            )
+    install(DIRECTORY ${CMAKE_BINARY_DIR}/man/
+            DESTINATION share/man/man8
+            FILES_MATCHING PATTERN "*.8"
+            )
 endif ()
 if (NOT WITH_DOC_HTML)
     set_target_properties(doc-html PROPERTIES EXCLUDE_FROM_ALL TRUE)
 else ()
     install(DIRECTORY ${CMAKE_BINARY_DIR}/html/
-            DESTINATION doc/html)
+            DESTINATION share/doc/${PROJECT_NAME})
 endif ()
 
 # This is required for custom command

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -180,7 +180,7 @@
 target_compile_definitions(ss-manager PUBLIC -DMODULE_MANAGER)
 target_compile_definitions(ss-local PUBLIC -DMODULE_LOCAL)
 target_compile_definitions(ss-redir PUBLIC -DMODULE_REDIR)
-target_compile_definitions(shadowsocks-libev PUBLIC -DMODULE_LOCAL)
+target_compile_definitions(shadowsocks-libev PUBLIC -DMODULE_LOCAL -DLIB_ONLY)
 
 target_link_libraries(ss-server cork ipset ${DEPS})
 target_link_libraries(ss-tunnel cork ${DEPS})

=== debian/changelog ===
shadowsocks-libev (3.3.4+ds-1ubuntu1) focal; urgency=medium

  * d/t/control: depend on python2
  * d/p/use-py2-for-dep8-tests.patch: be specific about the python
    version the tests need.

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 28 Jan 2020 14:34:14 -0300

shadowsocks-libev (3.3.4+ds-1) unstable; urgency=medium

  * New upstream release: v3.3.4
    - Minor bug fixes. (#2539, #2565, #2566, #2577)
    - Security bug fixes. (CVE-2019-5163, CVE-2019-5164)

 -- Roger Shimizu <rosh@debian.org>  Sun, 12 Jan 2020 01:08:12 +0900

shadowsocks-libev (3.3.3+ds-3) unstable; urgency=medium

  * debian/patches:
    - Add 0006 patch to fix FTBFS for Hurd. The patch is already
      accepted by upstream.
    - Cherry-pick 0007 from upstream to fix QoS issue.

 -- Roger Shimizu <rosh@debian.org>  Thu, 05 Dec 2019 03:12:27 +0900

shadowsocks-libev (3.3.3+ds-2) unstable; urgency=medium

  * debian/control:
    - Add Rules-Requires-Root: no
    - Add to shadowsocks-libev according to lintian:
      + Pre-Depends: ${misc:Pre-Depends}
    - Bump DH version from 10 to 12.
  * Add debian/upstream/metadata.
  * debian/patches:
    - Move 0001 patch to backport folder.
    - Cherry pick a few patches from upstream to fix TALOS-2019-0956
      (CVE-2019-5163), and TALOS-2019-0958.
      + [1ba753a] Fix #2536, TALOS-2019-0956 (CVE-2019-5163), which is
        a bug that IPv6 local address is not initialized when binding
        an IPv6 socket.
      + [ce71f49][748e6f3] Fix #2537, TALOS-2019-0958.
        Default listening path of ss-manager has been changed to
        ~/.ss-manager.socks.
      + [6d73201] Fix #2539, introduced by #2259.
  * debian/compat: Bump from 10 to 12.

 -- Roger Shimizu <rosh@debian.org>  Sun, 01 Dec 2019 19:38:38 +0900

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: shadowsocks-libev
 Section: net
 Priority: optional
-Maintainer: Debian Bridges Team <team+bridges@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Bridges Team <team+bridges@tracker.debian.org>
 Uploaders:
  Max Lv <max.c.lv@gmail.com>,
  Boyuan Yang <byang@debian.org>,
  Roger Shimizu <rosh@debian.org>
 Build-Depends:
  asciidoc-base | asciidoc,
- debhelper (>= 10),
+ debhelper (>= 12),
  libbloom-dev,
  libc-ares-dev,
  libcork-dev (>= 0.15.0+ds-8),
@@ -20,6 +21,7 @@
  pkg-config,
  xmlto,
 Standards-Version: 4.4.1
+Rules-Requires-Root: no
 Homepage: https://www.shadowsocks.org
 Vcs-Git: https://salsa.debian.org/bridges-team/shadowsocks-libev.git
 Vcs-Browser: https://salsa.debian.org/bridges-team/shadowsocks-libev
@@ -73,6 +75,8 @@
 Breaks:
  shadowsocks (<< 1.5.3-2),
 Architecture: any
+Pre-Depends:
+ ${misc:Pre-Depends},
 Depends:
  libcap2-bin [linux-any],
  lsb-base (>= 3.0-6),

=== debian/tests/control ===
Test-Command: bash tests/test.sh
Depends: @, python2, curl, dnsutils
Restrictions: allow-stderr
